﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;

namespace TableStructurePrint
{
    public partial class OledbDB : Form
    {
        
        OleDbConnection con; OleDbDataAdapter da; OleDbCommand cmd;
        Dictionary<string, string> DataTypes = new Dictionary<string, string>();
        public OledbDB()
        {
            InitializeComponent();
        }
        string PrepareCommandCode(string tableName, string commandType)
        {
            DataTable dt = new DataTable(tableName); OleDbDataAdapter da = null;
            OleDbCommand cmd = null; string cmdText = null, paraDefs = null, paraValues = "\r\n";
            DataColumn pk = null;
            tableName = dt.TableName;
            OleDbCommandBuilder cb = new OleDbCommandBuilder();
            if (commandType.Equals("Proc"))
            {

                cmd = new OleDbCommand(tableName, con);
                cmd.CommandType = CommandType.StoredProcedure;
                da = new OleDbDataAdapter();
                da.InsertCommand = cmd;
                cb.DataAdapter = da;
                //cmd = cb.GetInsertCommand(true);
                OleDbCommandBuilder.DeriveParameters(cmd);
                cmd.Parameters.Remove(cmd.Parameters["@RETURN_VALUE"]);
            }
            else
            {
                da = new OleDbDataAdapter("Select Top 1 * from " + tableName, con);
                da.FillSchema(dt, SchemaType.Source);
                cb.DataAdapter = da;
                if (commandType.Equals("Update") || commandType.Equals("Select"))
                {
                    try
                    {
                        cmd = cb.GetUpdateCommand(true);
                        //MessageBox.Show(cmd.Parameters.Count.ToString(), "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    catch (Exception ex)
                    {
                        string s = null;
                        if (ex is InvalidOperationException)
                        {
                            s = "//Error -> Can not generate Update command for table without Primary key";
                        }
                        else s = "//Error generating Update command -> " + ex.Message;
                        return s;
                    }
                }
                else if (commandType.Equals("Insert")) cmd = cb.GetInsertCommand(true);
                if (commandType.Equals("Select"))
                {
                    string s = null; 
                    foreach (DataColumn dc in dt.Columns)
                    {
                        s += (s == null ? null : ",") + dc.ColumnName;
                        if (dc.Unique) pk = dc;
                    }
                    s = "Select " + s + " From " + tableName;
                    if (pk != null)
                    {
                        s += " WHERE " + pk.ColumnName + "=@" + pk.ColumnName;
                    }
                    s = "OleDbCommand " + tableName + commandType + " = new OleDbCommand(\"" + s + "\", con);\r\n";
                    if (pk != null)
                    {
                        //paraDefs = tableName + commandType + ".Parameters.Add(\"@" + pk.ColumnName + "\",OleDbType." + cmd.Parameters["@" + pk.ColumnName].OleDbType.ToString() + ");\r\n";
                        //paraValues = tableName + commandType + ".Parameters[\"@" + pk.ColumnName + "\"].Value=" + this.GetParseCode(cmd.Parameters["@" + pk.ColumnName]) + ";\r\n";
                        string PkOleDbType;
                        if (DataTypes.ContainsValue(pk.DataType.Name)) PkOleDbType = DataTypes.FirstOrDefault(x => x.Value == pk.DataType.Name).Key;
                        else PkOleDbType = "Unknown";
                        paraDefs = tableName + commandType + ".Parameters.Add(\"@" + pk.ColumnName + "\",OleDbType." + PkOleDbType + ");\r\n";
                        
                        paraValues = tableName + commandType + ".Parameters[\"@" + pk.ColumnName + "\"].Value=" +  this.GetParseCode(pk) + ";\r\n";
                        s += paraDefs + paraValues;
                    }
                    return s;
                }
            }
            cmdText = cmd.CommandText;
            int ColsCount = dt.Columns.Count;
            DataColumn[] pkeys = dt.PrimaryKey;
            if (pkeys.Length > 0) { pk = pkeys[0]; ColsCount--; }
            if (commandType.Equals("Update"))
            {
                cmdText = cmdText.Substring(0, cmdText.IndexOf("WHERE ") + 6);
            }
            cmdText = "OleDbCommand " + tableName + commandType + " = new OleDbCommand(\"" + cmdText + "\", con);\r\n";
            
            if (commandType.Equals("Proc")) paraDefs = tableName + commandType + ".CommandType = CommandType.StoredProcedure;\r\n";
            int idx = 0; string paraName = null;
            foreach (OleDbParameter pm in cmd.Parameters)
            {
                if (idx == ColsCount) break;
                if (pm.ParameterName.IndexOf("@Original_") == -1 && pm.ParameterName.IndexOf("@IsNull_") == -1)
                {
                    //L1.Items.Add(pm.ParameterName + "-" + pm.SourceColumn );
                    ////paraDefs += tableName + commandType + ".Parameters.Add(\"" + dt.Columns[idx].ColumnName + "\",OleDbType." + pm.OleDbType.ToString() + (pm.Size == 0 ? null : "," + pm.Size) + ");\r\n";
                    paraDefs += tableName + commandType + ".Parameters.Add(\"" + pm.SourceColumn + "\",OleDbType." + pm.OleDbType.ToString() + (pm.Size == 0 ? null : "," + pm.Size) + ");\r\n";
                }
                idx++;
            }
            idx = 0;
            foreach (OleDbParameter pm in cmd.Parameters)
            {
                if (idx == ColsCount) break;
                if (pm.ParameterName.IndexOf("@Original_") == -1 && pm.ParameterName.IndexOf("@IsNull_") == -1)
                {
                    if (pm.Direction == ParameterDirection.Input)
                    {
                        ////paraValues += tableName + commandType + ".Parameters[\"" + dt.Columns[idx].ColumnName + "\"].Value=" + this.GetParseCode(pm) + ";\r\n";
                        paraValues += tableName + commandType + ".Parameters[\"" + pm.SourceColumn + "\"].Value=" + this.GetParseCode(dt.Columns[pm.SourceColumn]) + ";\r\n";
                    }
                    else
                    {
                        ////paraValues += tableName + commandType + ".Parameters[\"" + dt.Columns[idx].ColumnName + "\"].Direction = ParameterDirection.Output;" + "\r\n";
                        paraValues += tableName + commandType + ".Parameters[\"" + pm.SourceColumn + "\"].Direction = ParameterDirection.Output;" + "\r\n";
                    }
                }
                idx++;
            }
            if (commandType.Equals("Update"))
            {
                if (pk != null)
                {
                    //paraDefs = tableName + commandType + ".Parameters.Add(\"@" + pk.ColumnName + "\",OleDbType." + cmd.Parameters["@" + pk.ColumnName].OleDbType.ToString() + ");\r\n";
                    //paraValues = tableName + commandType + ".Parameters[\"@" + pk.ColumnName + "\"].Value=" + this.GetParseCode(cmd.Parameters["@" + pk.ColumnName]) + ";\r\n";
                    string PkOleDbType;
                    if (DataTypes.ContainsValue(pk.DataType.Name)) PkOleDbType = DataTypes.FirstOrDefault(x => x.Value == pk.DataType.Name).Key;
                    else PkOleDbType = "Unknown";
                    paraDefs += tableName + commandType + ".Parameters.Add(\"@" + pk.ColumnName + "\",OleDbType." + PkOleDbType + ");\r\n";

                    paraValues += tableName + commandType + ".Parameters[\"@" + pk.ColumnName + "\"].Value=" + this.GetParseCode(pk) + ";\r\n";
                }
            }
            return cmdText + paraDefs + paraValues;
        }

        string GetParseCode(OleDbParameter pm)
        {
            string s = pm.ParameterName.Substring(1);
            s = "txt" + s.Substring(0, 1).ToUpper() + s.Substring(1) + ".Text";
            if (pm.OleDbType.ToString().IndexOf("Char") == -1)
            {
                if (DataTypes.ContainsKey(pm.OleDbType.ToString()))
                {
                    s = DataTypes[pm.OleDbType.ToString()] + ".Parse(" + s + ")";
                }
            }
            return s;
        }

        string GetParseCode(DataColumn dc)
        {
            string s = dc.ColumnName;
            s = "txt" + s.Substring(0, 1).ToUpper() + s.Substring(1) + ".Text";
            if (!dc.DataType.Name.Equals("String"))
            {
                s = dc.DataType.Name + ".Parse(" + s + ")";
            }
            return s;
        }

        private void OleDbDB_Load(object sender, EventArgs e)
        {
            DataTypes.Add("BigInt", "Int64");
            DataTypes.Add("VarBinary", "Byte[]");
            DataTypes.Add("Bit", "Boolean");
            DataTypes.Add("Char", "String");
            DataTypes.Add("Date", "DateTime");
            DataTypes.Add("DateTime", "DateTime");
            DataTypes.Add("DateTime2", "DateTime");
            DataTypes.Add("DateTimeOffset", "DateTimeOffset");
            DataTypes.Add("Decimal", "Decimal");
            DataTypes.Add("Float", "Double");
            DataTypes.Add("Binary", "Byte[]");
            DataTypes.Add("Int", "Int32");
            DataTypes.Add("Money", "Decimal");
            DataTypes.Add("NChar", "String");
            DataTypes.Add("NText", "String");
            DataTypes.Add("NVarChar", "String");
            DataTypes.Add("Real", "Single");
            DataTypes.Add("Timestamp", "Byte[]");
            DataTypes.Add("SmallInt", "Int16");
            DataTypes.Add("SmallMoney", "Decimal");
            //DataTypes.Add("Variant", "Object *");
            DataTypes.Add("Text", "String");
            DataTypes.Add("Time", "TimeSpan");
            DataTypes.Add("TinyInt", "Byte");
            //DataTypes.Add("UniqueIdentifier", "Guid");
            //DataTypes.Add("VarChar", "String");
            //DataTypes.Add("Xml", "Xml");
           
        }

        private void OleDbDB_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (con != null) con.Close();
        }

        private void cmdConnect_Click(object sender, EventArgs e)
        {
            con = new OleDbConnection(txtCOnnectionString.Text);

            try
            {
                con.Open();
                da = new OleDbDataAdapter();
                this.ShowTables(ref con);
            }
            catch(Exception ex)
            {
                //MessageBox.Show("Connection Error", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                MessageBox.Show(ex.ToString() , "", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        void ShowTables(ref OleDbConnection con)
        {
            DataTable tb = con.GetSchema("Tables");
            foreach (DataRow row in tb.Rows)
            {
                int n = dg.Rows.Add();
                dg.Rows[n].Cells["ColGenCode"].Value = "Gen Code";
                dg.Rows[n].Cells["ColObjectName"].Value = row["TABLE_NAME"];
                dg.Rows[n].Cells["ColObjectType"].Value = "Table";
            }

            //tb = con.GetSchema("Procedures");
            //foreach (DataRow row in tb.Rows)
            //{
            //    if (!(row["SPECIFIC_NAME"].ToString().StartsWith("sp_") || row["SPECIFIC_NAME"].ToString().StartsWith("fn_")))
            //    {
            //        int n = dg.Rows.Add();
            //        dg.Rows[n].Cells["ColGenCode"].Value = "Gen Code";
            //        dg.Rows[n].Cells["ColObjectName"].Value = row["SPECIFIC_NAME"];
            //        dg.Rows[n].Cells["ColObjectType"].Value = row["ROUTINE_TYPE"];
            //    }
            //}

        }

        private void dg_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (e.ColumnIndex == 0)
            {
                string objName, objType, s = null;
                int row = e.RowIndex;
                objName = dg.Rows[row].Cells[1].Value.ToString();
                objType = dg.Rows[row].Cells[2].Value.ToString();
                if (objType.Equals("Table"))
                {
                    s = this.PrepareCommandCode(objName, "Select");
                    s += "\r\n" + this.PrepareCommandCode(objName, "Insert");
                    s += "\r\n" + this.PrepareCommandCode(objName, "Update");
                }
                else
                {
                    s = this.PrepareCommandCode(objName, "Proc");
                }
                t.Text = s;
                //MessageBox.Show(row.ToString());
            }
        }



    }
}
