﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TableStructurePrint
{
    public partial class SqlServerDB : Form
    {
        SqlConnection con; SqlDataAdapter da; SqlCommand cmd;
        Dictionary<string, string> DataTypes = new Dictionary<string, string>();
        public SqlServerDB()
        {
            InitializeComponent();
        }
        string PrepareCommandCode(string tableName, string commandType)
        {
            DataTable dt = new DataTable(tableName); SqlDataAdapter da=null;
            SqlCommand cmd=null; string cmdText = null, paraDefs = null, paraValues = "\r\n";
           
            tableName = dt.TableName;
            SqlCommandBuilder cb = new SqlCommandBuilder();
            if (commandType.Equals("Proc"))
            {

                cmd = new SqlCommand(tableName, con);
                cmd.CommandType=CommandType.StoredProcedure;
                da = new SqlDataAdapter();
                da.InsertCommand = cmd;
                cb.DataAdapter = da;
                //cmd = cb.GetInsertCommand(true);
                SqlCommandBuilder.DeriveParameters(cmd);
                cmd.Parameters.Remove(cmd.Parameters["@RETURN_VALUE"]);
            }
            else
            {
                da = new SqlDataAdapter("Select Top 1 * from " + tableName, con);
                da.FillSchema(dt, SchemaType.Source);
                cb.DataAdapter = da;
                if (commandType.Equals("Update"))
                {
                    try
                    {
                        cmd = cb.GetUpdateCommand(true);
                    }
                    catch (Exception ex)
                    {
                        string s = null;
                        if (ex is InvalidOperationException)
                        {
                            s = "//Error -> Can not generate Update command for table without Primary key";
                        }
                        else s = "//Error generating Update command -> " + ex.Message;
                        return s;
                    }
                }
                else if (commandType.Equals("Insert") || commandType.Equals("Select")) cmd = cb.GetInsertCommand(true);
                if (commandType.Equals("Select"))
                {
                    string s = null; DataColumn pk = null;
                    foreach (DataColumn dc in dt.Columns)
                    {
                        s += (s == null ? null : ",") + dc.ColumnName;
                        if (dc.Unique) pk = dc;
                    }
                    s = "Select " + s + " From " + tableName;
                    if (pk != null)
                    {
                        s += " WHERE " + pk.ColumnName + "=@" + pk.ColumnName;
                    }
                    s = "SqlCommand " + tableName + commandType + " = new SqlCommand(\"" + s + "\", con);\r\n";
                    if (pk != null)
                    {
                        paraDefs = tableName + commandType + ".Parameters.Add(\"@" + pk.ColumnName + "\",SqlDbType." + cmd.Parameters["@" + pk.ColumnName].SqlDbType.ToString() + ");\r\n";
                        paraValues = tableName + commandType + ".Parameters[\"@" + pk.ColumnName + "\"].Value=" + this.GetParseCode(cmd.Parameters["@" + pk.ColumnName]) + ";\r\n";
                        s += paraDefs + paraValues;
                    }
                    return s;
                }
            }
            cmdText = cmd.CommandText;
            if (commandType.Equals("Update"))
            {
                cmdText = cmdText.Substring(0, cmdText.IndexOf("WHERE ") + 6);
            }
            cmdText = "SqlCommand " + tableName + commandType + " = new SqlCommand(\"" + cmdText + "\", con);\r\n";

            if (commandType.Equals("Proc")) paraDefs = tableName + commandType + ".CommandType = CommandType.StoredProcedure;\r\n";
            foreach (SqlParameter pm in cmd.Parameters)
            {
                if (pm.ParameterName.IndexOf("@Original_") == -1 && pm.ParameterName.IndexOf("@IsNull_") == -1)
                {
                    paraDefs += tableName + commandType + ".Parameters.Add(\"" + pm.ParameterName + "\",SqlDbType." + pm.SqlDbType.ToString() + (pm.Size == 0 ? null : "," + pm.Size) + ");\r\n";
                }
            }
            foreach (SqlParameter pm in cmd.Parameters)
            {
                if (pm.ParameterName.IndexOf("@Original_") == -1 && pm.ParameterName.IndexOf("@IsNull_") == -1)
                {
                    if (pm.Direction == ParameterDirection.Input)
                    {
                        paraValues += tableName + commandType + ".Parameters[\"" + pm.ParameterName + "\"].Value=" + this.GetParseCode(pm) + ";\r\n";
                    }
                    else
                    {
                        paraValues += tableName + commandType + ".Parameters[\"" + pm.ParameterName + "\"].Direction = ParameterDirection.Output;" + "\r\n";
                    }
                }
            }
            return cmdText + paraDefs + paraValues;
        }
        
        string GetParseCode(SqlParameter pm)
        {
            string s = pm.ParameterName.Substring(1);
            s = "txt" + s.Substring(0,1).ToUpper() + s.Substring(1) + ".Text";
            if (pm.SqlDbType.ToString().IndexOf("Char") == -1)
            {
                if (DataTypes.ContainsKey(pm.SqlDbType.ToString()))
                {
                    s = DataTypes[pm.SqlDbType.ToString()] + ".Parse(" + s + ")";
                }
            }
            return s;
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            DataTypes.Add("BigInt", "Int64");
            DataTypes.Add("VarBinary", "Byte[]");
            DataTypes.Add("Bit", "Boolean");
            DataTypes.Add("Char", "String");
            DataTypes.Add("Date", "DateTime");
            DataTypes.Add("DateTime", "DateTime");
            DataTypes.Add("DateTime2", "DateTime");
            DataTypes.Add("DateTimeOffset", "DateTimeOffset");
            DataTypes.Add("Decimal", "Decimal");
            DataTypes.Add("Float", "Double");
            DataTypes.Add("Binary", "Byte[]");
            DataTypes.Add("Int", "Int32");
            DataTypes.Add("Money", "Decimal");
            DataTypes.Add("NChar", "String");
            DataTypes.Add("NText", "String");
            DataTypes.Add("NVarChar", "String");
            DataTypes.Add("Real", "Single");
            DataTypes.Add("Timestamp", "Byte[]");
            DataTypes.Add("SmallInt", "Int16");
            DataTypes.Add("SmallMoney", "Decimal");
            //DataTypes.Add("Variant", "Object *");
            DataTypes.Add("Text", "String");
            DataTypes.Add("Time", "TimeSpan");
            DataTypes.Add("TinyInt", "Byte");
            //DataTypes.Add("UniqueIdentifier", "Guid");
            //DataTypes.Add("VarChar", "String");
            //DataTypes.Add("Xml", "Xml");

        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
           if(con!=null) con.Close();
        }

        private void cmdConnect_Click(object sender, EventArgs e)
        {
            con = new SqlConnection(txtCOnnectionString.Text);
            
            try
            {
                con.Open();
                da = new SqlDataAdapter();
                this.ShowTables(ref con);
            }
            catch
            {
                MessageBox.Show("Connection Error", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        void ShowTables(ref SqlConnection con)
        {
            DataTable tb = con.GetSchema("Tables");
            //DataTable tb = con.GetSchema();
            //dg.DataSource = tb.DefaultView;
            //return;
            foreach (DataRow row in tb.Rows)
            {
                int n = dg.Rows.Add();
                dg.Rows[n].Cells["ColGenCode"].Value = "Gen Code";
                dg.Rows[n].Cells["ColObjectName"].Value = row["TABLE_NAME"];
                dg.Rows[n].Cells["ColObjectType"].Value = "Table";
            }

            tb = con.GetSchema("Procedures");
            foreach(DataRow row in tb.Rows)
            {
                if (!(row["SPECIFIC_NAME"].ToString().StartsWith("sp_") || row["SPECIFIC_NAME"].ToString().StartsWith("fn_")))
                {
                    int n = dg.Rows.Add();
                    dg.Rows[n].Cells["ColGenCode"].Value = "Gen Code";
                    dg.Rows[n].Cells["ColObjectName"].Value = row["SPECIFIC_NAME"];
                    dg.Rows[n].Cells["ColObjectType"].Value = row["ROUTINE_TYPE"];
                }
            }
            
        }

        private void dg_EditingControlShowing(object sender, DataGridViewEditingControlShowingEventArgs e)
        {
            if (e.Control is Button)
            {
                int row = dg.CurrentCell.RowIndex;
                MessageBox.Show(row.ToString());
            }
        }

        private void dg_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (e.ColumnIndex == 0)
            {
                string objName, objType,s=null;
                int row = e.RowIndex;
                objName = dg.Rows[row].Cells[1].Value.ToString();
                objType = dg.Rows[row].Cells[2].Value.ToString();
                if (objType.Equals("Table"))
                {
                    s = this.PrepareCommandCode(objName, "Select");
                    s += "\r\n" + this.PrepareCommandCode(objName, "Insert");
                    s += "\r\n" + this.PrepareCommandCode(objName, "Update");
                }
                else
                {
                    s = this.PrepareCommandCode(objName, "Proc");
                }
                t.Text = s;
                //MessageBox.Show(row.ToString());
            }
        }
    }
}
